var __decorate=this&&this.__decorate||function(e,t,r,o){var i,n=arguments.length,s=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,r):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,r,o);else for(var a=e.length-1;a>=0;a--)(i=e[a])&&(s=(n<3?i(s):n>3?i(t,r,s):i(t,r))||s);return n>3&&s&&Object.defineProperty(t,r,s),s};import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as PublicExtensions from"../../models/extensions/extensions.js";import*as Emulation from"../../panels/emulation/emulation.js";import*as Timeline from"../../panels/timeline/timeline.js";import*as Buttons from"../../ui/components/buttons/buttons.js";import*as ComponentHelpers from"../../ui/components/helpers/helpers.js";import*as IconButton from"../../ui/components/icon_button/icon_button.js";import*as UI from"../../ui/legacy/legacy.js";import*as LitHtml from"../../ui/lit-html/lit-html.js";import*as Tracing from"../../services/tracing/tracing.js";import*as Menus from"../../ui/components/menus/menus.js";import*as Dialogs from"../../ui/components/dialogs/dialogs.js";import*as Components from"./components/components.js";import*as Converters from"./converters/converters.js";import*as Extensions from"./extensions/extensions.js";import*as Models from"./models/models.js";import recorderControllerStyles from"./recorderController.css.js";import*as Events from"./RecorderEvents.js";const{html:html,Decorators:Decorators,LitElement:LitElement}=LitHtml,{customElement:customElement,state:state}=Decorators,UIStrings={createRecording:"Create a new recording",importRecording:"Import recording",deleteRecording:"Delete recording",continueReplay:"Continue",stepOverReplay:"Execute one step",exportRecording:"Export",startStopRecording:"Start/Stop recording",replayRecording:"Replay recording",copyShortcut:"Copy recording or selected step",toggleCode:"Toggle code view",export:"Export",exportViaExtensions:"Export via extensions",getExtensions:"Get extensions…",sendFeedback:"Send feedback"},str_=i18n.i18n.registerUIStrings("panels/recorder/RecorderController.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),GET_EXTENSIONS_MENU_ITEM="get-extensions-link",GET_EXTENSIONS_URL="https://goo.gle/recorder-extension-list",CONVERTER_ID_TO_METRIC={json:Host.UserMetrics.RecordingExported.ToJSON,"@puppeteer/replay":Host.UserMetrics.RecordingExported.ToPuppeteerReplay,puppeteer:Host.UserMetrics.RecordingExported.ToPuppeteer,lighthouse:Host.UserMetrics.RecordingExported.ToLighthouse};export let RecorderController=class extends LitElement{static styles=[recorderControllerStyles];#e=Models.RecordingStorage.RecordingStorage.instance();#t=Models.ScreenshotStorage.ScreenshotStorage.instance();#r=!0;#o={isPlaying:!1,isPausedOnBreakpoint:!1};#i;#n;#s=new Set;#a;#c=new Models.RecorderSettings.RecorderSettings;#d=new Models.RecorderShortcutHelper.RecorderShortcutHelper;constructor(){super(),this.isRecording=!1,this.isToggling=!1,this.exportMenuExpanded=!1,this.currentPage="StartPage",this.#e.getRecordings().length&&this.#g("AllRecordingsPage");const e=Common.Settings.Settings.instance().moduleSetting("textEditorIndent").get();this.#a=Object.freeze([new Converters.JSONConverter.JSONConverter(e),new Converters.PuppeteerReplayConverter.PuppeteerReplayConverter(e),new Converters.PuppeteerConverter.PuppeteerConverter(e),new Converters.LighthouseConverter.LighthouseConverter(e)]);const t=Extensions.ExtensionManager.ExtensionManager.instance();this.#l(t.extensions()),t.addEventListener(Extensions.ExtensionManager.Events.ExtensionsUpdated,(e=>{this.#l(e.data)})),this.addEventListener("setrecording",(e=>this.#h(e)))}disconnectedCallback(){super.disconnectedCallback(),this.currentRecordingSession&&this.currentRecordingSession.stop()}#l(e){this.extensionConverters=e.filter((e=>e.getCapabilities().includes("export"))).map(((e,t)=>new Converters.ExtensionConverter.ExtensionConverter(t,e))),this.replayExtensions=e.filter((e=>e.getCapabilities().includes("replay")))}setIsRecordingStateForTesting(e){this.isRecording=e}setRecordingStateForTesting(e){this.#o.isPlaying=e.isPlaying,this.#o.isPausedOnBreakpoint=e.isPausedOnBreakpoint}setCurrentPageForTesting(e){this.#g(e)}getCurrentPageForTesting(){return this.currentPage}getCurrentRecordingForTesting(){return this.currentRecording}getStepBreakpointIndexesForTesting(){return[...this.#s.values()]}#p(){this.importError=void 0}async#u(e){const t=new Common.StringOutputStream.StringOutputStream,r=new Bindings.FileUtils.ChunkedFileReader(e,1e7);if(!await r.read(t))throw r.error();let o;try{o=Models.SchemaUtils.parse(JSON.parse(t.data()))}catch(e){return void(this.importError=e)}this.#R(await this.#e.saveRecording(o)),this.#g("RecordingPage"),this.#p()}setCurrentRecordingForTesting(e){this.#R(e)}getSectionsForTesting(){return this.sections}#R(e,t={}){const{keepBreakpoints:r=!1,updateSession:o=!1}=t;this.recordingPlayer?.abort(),this.currentStep=void 0,this.recordingError=void 0,this.lastReplayResult=void 0,this.recordingPlayer=void 0,this.#o.isPlaying=!1,this.#o.isPausedOnBreakpoint=!1,this.#s=r?this.#s:new Set,e?(this.currentRecording=e,this.sections=Models.Section.buildSections(e.flow.steps),this.settings=this.#m(e.flow),o&&this.currentRecordingSession&&this.currentRecordingSession.overwriteUserFlow(e.flow)):(this.currentRecording=void 0,this.sections=void 0,this.settings=void 0),this.#S()}#g(e){e!==this.currentPage&&(this.previousPage=this.currentPage,this.currentPage=e)}#m(e){const t=e.steps,r=t.findIndex((e=>"navigate"===e.type)),o={timeout:e.timeout};for(let e=r-1;e>=0;e--){const r=t[e];if(o.viewportSettings||"setViewport"!==r.type||(o.viewportSettings=r),!o.networkConditionsSettings&&"emulateNetworkConditions"===r.type){o.networkConditionsSettings={...r};for(const e of[SDK.NetworkManager.OfflineConditions,SDK.NetworkManager.Slow3GConditions,SDK.NetworkManager.Fast3GConditions])SDK.NetworkManager.networkConditionsEqual({...e,title:e.i18nTitleKey||""},{...r,title:e.i18nTitleKey||""})&&(o.networkConditionsSettings.title=e.title instanceof Function?e.title():e.title,o.networkConditionsSettings.i18nTitleKey=e.i18nTitleKey)}}return o}#w(){const e=SDK.TargetManager.TargetManager.instance().primaryPageTarget();if(!e)throw new Error("Missing main page target");return e}#y(e){if(!this.sections)return null;for(const t of this.sections)if(-1!==t.steps.indexOf(e))return t;return null}#S(){if(!this.sections||!this.currentRecording)return;const e=this.currentRecording.storageName;for(let t=0;t<this.sections.length;t++){const r=this.#t.getScreenshotForSection(e,t);this.sections[t].screenshot=r||void 0}this.requestUpdate()}#v(){this.recordingPlayer?.abort()}async#C(e){if(!this.currentRecording||!this.#r)return;const t=PublicExtensions.RecorderPluginManager.RecorderPluginManager.instance().once(PublicExtensions.RecorderPluginManager.Events.ShowViewRequested);e.replay(this.currentRecording.flow);const r=await t;this.viewDescriptor=r,Host.userMetrics.recordingReplayStarted(Host.UserMetrics.RecordingReplayStarted.ReplayViaExtension)}async#E(e){if(!this.currentRecording||!this.#r)return;if(this.viewDescriptor&&(this.viewDescriptor=void 0),e.data.extension)return this.#C(e.data.extension);Host.userMetrics.recordingReplayStarted("chrome_recorder"!==e.data.targetPanel?Host.UserMetrics.RecordingReplayStarted.ReplayWithPerformanceTracing:Host.UserMetrics.RecordingReplayStarted.ReplayOnly),this.#o.isPlaying=!0,this.currentStep=void 0,this.recordingError=void 0,this.lastReplayResult=void 0;const t=this.currentRecording;this.#p(),await this.#f(),this.recordingPlayer=new Models.RecordingPlayer.RecordingPlayer(this.currentRecording.flow,{speed:e.data.speed,breakpointIndexes:this.#s});const r="timeline"===e.data.targetPanel,o=new Set;this.recordingPlayer.addEventListener("Step",(async({data:{step:e,resolve:r}})=>{this.currentStep=e;const i=this.#y(e);if(this.sections&&i&&!o.has(i)){o.add(i);const e=this.sections.indexOf(i),r=await Models.ScreenshotUtils.takeScreenshot();i.screenshot=r,Models.ScreenshotStorage.ScreenshotStorage.instance().storeScreenshotForSection(t.storageName,e,r)}r()})),this.recordingPlayer.addEventListener("Stop",(()=>{this.#o.isPausedOnBreakpoint=!0,this.requestUpdate()})),this.recordingPlayer.addEventListener("Continue",(()=>{this.#o.isPausedOnBreakpoint=!1,this.requestUpdate()})),this.recordingPlayer.addEventListener("Error",(({data:e})=>{this.recordingError=e,r||(this.#o.isPlaying=!1,this.recordingPlayer=void 0),this.lastReplayResult="Failure";const t=e.message.toLowerCase();t.startsWith("could not find element")?Host.userMetrics.recordingReplayFinished(Host.UserMetrics.RecordingReplayFinished.TimeoutErrorSelectors):t.startsWith("waiting for target failed")?Host.userMetrics.recordingReplayFinished(Host.UserMetrics.RecordingReplayFinished.TimeoutErrorTarget):Host.userMetrics.recordingReplayFinished(Host.UserMetrics.RecordingReplayFinished.OtherError)})),this.recordingPlayer.addEventListener("Done",(()=>{r||(this.#o.isPlaying=!1,this.recordingPlayer=void 0),this.lastReplayResult="Success",this.dispatchEvent(new Events.ReplayFinishedEvent),Host.userMetrics.recordingReplayFinished(Host.UserMetrics.RecordingReplayFinished.Success)})),this.recordingPlayer.addEventListener("Abort",(()=>{this.currentStep=void 0,this.recordingError=void 0,this.lastReplayResult=void 0,this.#o.isPlaying=!1}));let i=e=>{};const n=new Promise((e=>{i=e}));let s=null;if("timeline"===e.data?.targetPanel)s=new Tracing.PerformanceTracing.PerformanceTracing(this.#w(),{tracingBufferUsage(){},eventsRetrievalProgress(){},tracingComplete(e){i(e)}});if(s&&await s.start(),this.#P(!1),await this.recordingPlayer.play(),this.#P(!0),s){await s.stop();const t=await n;if(this.#o.isPlaying=!1,this.recordingPlayer=void 0,await UI.InspectorView.InspectorView.instance().showPanel(e.data?.targetPanel),"timeline"===e.data?.targetPanel)Timeline.TimelinePanel.TimelinePanel.instance().loadFromEvents(t)}}async#f(){try{const e=Emulation.DeviceModeWrapper.DeviceModeWrapper.instance();if(e.isDeviceModeOn()){e.toggleDeviceMode();const t=this.#w().model(SDK.EmulationModel.EmulationModel);await(t?.emulateDevice(null))}}catch{}}#P(e){const t=this.#w().model(SDK.EmulationModel.EmulationModel);t?.setTouchEmulationAllowed(e)}async#h(e){const t=JSON.parse(e.detail);this.#R(await this.#e.saveRecording(Models.SchemaUtils.parse(t))),this.#g("RecordingPage"),this.#p()}getUserFlow(){return this.currentRecording?.flow}async#x(e){if(!this.currentRecording)throw new Error("Current recording expected to be defined.");const t={...this.currentRecording,flow:{...this.currentRecording.flow,steps:this.currentRecording.flow.steps.map((t=>t===e.currentStep?e.newStep:t))}};this.#R(await this.#e.updateRecording(t.storageName,t.flow),{keepBreakpoints:!0,updateSession:!0})}async#M(e){if(!this.currentRecording)throw new Error("Current recording expected to be defined.");const t=e.stepOrSection;let r,o=e.position;if("steps"in t){const i=this.sections?.indexOf(t);if(void 0===i||-1===i)throw new Error("There is no section to add a step to");if("after"===e.position)this.sections?.[i].steps.length?(r=this.sections?.[i].steps[0],o="before"):(r=this.sections?.[i].causingStep,o="after");else{if(i<=0)throw new Error("There is no section to add a step to");const e=this.sections?.[i-1];r=e?.steps[e.steps.length-1],o="after"}}else r=t;if(!r)throw new Error("Anchor step is not found when adding a step");const i=this.currentRecording.flow.steps,n=i.indexOf(r)+("before"===o?0:1);i.splice(n,0,{type:Models.Schema.StepType.WaitForElement,selectors:["body"]});const s={...this.currentRecording,flow:{...this.currentRecording.flow,steps:i}};Host.userMetrics.recordingEdited(Host.UserMetrics.RecordingEdited.StepAdded),this.#s=new Set([...this.#s.values()].map((e=>n>e?e:e+1))),this.#R(await this.#e.updateRecording(s.storageName,s.flow),{keepBreakpoints:!0,updateSession:!0})}async#T(e){if(!this.currentRecording)throw new Error("Current recording expected to be defined.");const t={...this.currentRecording.flow,title:e.title};this.#R(await this.#e.updateRecording(this.currentRecording.storageName,t))}async#$(e){if(!this.currentRecording)throw new Error("Current recording expected to be defined.");const t=this.currentRecording.flow.steps,r=t.indexOf(e.step);t.splice(r,1);const o={...this.currentRecording.flow,steps:t};Host.userMetrics.recordingEdited(Host.UserMetrics.RecordingEdited.StepRemoved),this.#s=new Set([...this.#s.values()].map((e=>r>e?e:r===e?-1:e-1)).filter((e=>e>=0))),this.#R(await this.#e.updateRecording(this.currentRecording.storageName,o),{keepBreakpoints:!0,updateSession:!0})}async#N(e){if(!this.currentRecording)throw new Error("Current recording expected to be defined.");const t=this.currentRecording.flow.steps.findIndex((e=>"navigate"===e.type));if(-1===t)throw new Error("Current recording does not have a navigate step");const r=this.currentRecording.flow.steps.findIndex(((e,r)=>!(r>=t)&&"emulateNetworkConditions"===e.type));if(e.data)if(-1===r)this.currentRecording.flow.steps.splice(0,0,Models.SchemaUtils.createEmulateNetworkConditionsStep({download:e.data.download,upload:e.data.upload,latency:e.data.latency}));else{const t=this.currentRecording.flow.steps[r];t.download=e.data.download,t.upload=e.data.upload,t.latency=e.data.latency}else-1!==r&&this.currentRecording.flow.steps.splice(r,1);this.#R(await this.#e.updateRecording(this.currentRecording.storageName,this.currentRecording.flow))}async#I(e){if(!this.currentRecording)throw new Error("Current recording expected to be defined.");this.currentRecording.flow.timeout=e.data,this.#R(await this.#e.updateRecording(this.currentRecording.storageName,this.currentRecording.flow))}async#b(e){if(e.stopPropagation(),e instanceof Components.RecordingListView.DeleteRecordingEvent)await this.#e.deleteRecording(e.storageName),this.#t.deleteScreenshotsForRecording(e.storageName),this.requestUpdate();else{if(!this.currentRecording)return;await this.#e.deleteRecording(this.currentRecording.storageName),this.#t.deleteScreenshotsForRecording(this.currentRecording.storageName)}(await this.#e.getRecordings()).length?this.#g("AllRecordingsPage"):this.#g("StartPage"),this.#R(void 0),this.#p()}#k(e){e?.stopPropagation(),this.#g("CreateRecordingPage"),this.#p()}async#B(e){await this.#f(),this.isToggling=!0,this.#p(),Host.userMetrics.recordingToggled(Host.UserMetrics.RecordingToggled.RecordingStarted),this.currentRecordingSession=new Models.RecordingSession.RecordingSession(this.#w(),{title:e.name,selectorAttribute:e.selectorAttribute,selectorTypesToRecord:e.selectorTypesToRecord.length?e.selectorTypesToRecord:Object.values(Models.Schema.SelectorType)}),this.#R(await this.#e.saveRecording(this.currentRecordingSession.cloneUserFlow()));let t,r=-1;const o=async e=>{if(!this.sections)throw new Error("Could not find sections.");const o=this.sections.length-1,i=this.sections[o];if(t||r===o)return;t=Models.ScreenshotUtils.takeScreenshot();const n=await t;t=void 0,i.screenshot=n,Models.ScreenshotStorage.ScreenshotStorage.instance().storeScreenshotForSection(e.storageName,o,n),r=o,this.#S()};this.currentRecordingSession.addEventListener("recordingupdated",(async({data:e})=>{if(!this.currentRecording)throw new Error("No current recording found");this.#R(await this.#e.updateRecording(this.currentRecording.storageName,e));const t=this.shadowRoot?.querySelector("devtools-recording-view");t?.scrollToBottom(),await o(this.currentRecording)})),this.currentRecordingSession.addEventListener("recordingstopped",(async({data:e})=>{if(!this.currentRecording)throw new Error("No current recording found");Host.userMetrics.keyboardShortcutFired("chrome_recorder.start-recording"),this.#R(await this.#e.updateRecording(this.currentRecording.storageName,e)),await this.#_()})),await this.currentRecordingSession.start(),this.isToggling=!1,this.isRecording=!0,this.#g("RecordingPage"),this.dispatchEvent(new Events.RecordingStateChangedEvent(this.currentRecording.flow))}async#_(){if(!this.currentRecording||!this.currentRecordingSession)throw new Error("Recording was never started");this.isToggling=!0,this.#p(),Host.userMetrics.recordingToggled(Host.UserMetrics.RecordingToggled.RecordingFinished),await this.currentRecordingSession.stop(),this.currentRecordingSession=void 0,this.isToggling=!1,this.isRecording=!1,this.dispatchEvent(new Events.RecordingStateChangedEvent(this.currentRecording.flow))}async#U(){this.previousPage&&this.#g(this.previousPage)}async#F(e){const t=e instanceof Components.RecordingListView.OpenRecordingEvent||e instanceof Components.RecordingListView.PlayRecordingEvent?e.storageName:e.target?.value;this.#R(await this.#e.getRecording(t)),this.currentRecording?this.#g("RecordingPage"):"StartPage"===t?this.#g("StartPage"):"AllRecordingsPage"===t&&this.#g("AllRecordingsPage")}async#A(e){if("string"!=typeof e.itemValue)throw new Error("Invalid export option value");if("get-extensions-link"===e.itemValue)return void Host.InspectorFrontendHost.InspectorFrontendHostInstance.openInNewTab(GET_EXTENSIONS_URL);if(!this.currentRecording)throw new Error("No recording selected");const t=e.itemValue,r=e=>e.getId()===t,o=this.#a.find(r)||this.extensionConverters.find(r);if(!o)throw new Error("No recording selected");const[i]=await o.stringify(this.currentRecording.flow);await this.#D(o.getFilename(this.currentRecording.flow),i);const n=CONVERTER_ID_TO_METRIC[o.getId()];if(n)Host.userMetrics.recordingExported(n);else{if(!o.getId().startsWith(Converters.ExtensionConverter.EXTENSION_PREFIX))throw new Error("Could not find a metric for the export option with id = "+t);Host.userMetrics.recordingExported(Host.UserMetrics.RecordingExported.ToExtension)}}async#D(e,t){try{const r=await window.showSaveFilePicker({suggestedName:e}),o=await r.createWritable();await o.write(t),await o.close()}catch(e){if("AbortError"===e.name)return;throw e}}async#H(){if(!this.currentRecordingSession||!this.currentRecording)return;const e=this.currentRecordingSession.cloneUserFlow();e.steps.push({type:"waitForElement",selectors:[[".cls"]]}),this.#R(await this.#e.updateRecording(this.currentRecording.storageName,e),{keepBreakpoints:!0,updateSession:!0}),Host.userMetrics.recordingAssertion(Host.UserMetrics.RecordingAssertion.AssertionAdded),await this.updateComplete,this.renderRoot.querySelector("devtools-recording-view")?.shadowRoot?.querySelector(".section:last-child devtools-step-view:last-of-type")?.shadowRoot?.querySelector(".action")?.click()}#O(e){e.stopPropagation(),this.#p(),this.#i=UI.UIUtils.createFileSelectorElement(this.#u.bind(this)),this.#i.click()}async#V(e){await this.#F(e),await this.#E(new Components.RecordingView.PlayRecordingEvent({targetPanel:"chrome_recorder",speed:this.#c.speed}))}#L=e=>{this.#s.add(e.index),this.recordingPlayer?.updateBreakpointIndexes(this.#s),this.requestUpdate()};#j=e=>{this.#s.delete(e.index),this.recordingPlayer?.updateBreakpointIndexes(this.#s),this.requestUpdate()};#q(){this.viewDescriptor=void 0}handleActions(e){if(this.isActionPossible(e))switch(e){case"chrome_recorder.create-recording":return void this.#k();case"chrome_recorder.start-recording":if("CreateRecordingPage"===this.currentPage||this.isRecording)if("CreateRecordingPage"===this.currentPage){const e=this.renderRoot.querySelector("devtools-create-recording-view");e&&this.#d.handleShortcut(e.startRecording.bind(e))}else this.isRecording&&this.#_();else this.#d.handleShortcut(this.#B.bind(this,new Components.CreateRecordingView.RecordingStartedEvent(this.#c.defaultTitle,this.#c.defaultSelectors,this.#c.selectorAttribute)));return;case"chrome_recorder.replay-recording":return void this.#E(new Components.RecordingView.PlayRecordingEvent({targetPanel:"chrome_recorder",speed:this.#c.speed}));case"chrome_recorder.toggle-code-view":{const e=this.renderRoot.querySelector("devtools-recording-view");return void(e&&e.showCodeToggle())}}}isActionPossible(e){switch(e){case"chrome_recorder.create-recording":return!this.isRecording&&!this.#o.isPlaying;case"chrome_recorder.start-recording":return!this.#o.isPlaying;case"chrome_recorder.replay-recording":return"RecordingPage"===this.currentPage&&!this.#o.isPlaying;case"chrome_recorder.toggle-code-view":return"RecordingPage"===this.currentPage}}#K(){const e=e=>UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutsForAction(e).map((e=>e.title()));return[{title:i18nString(UIStrings.startStopRecording),bindings:e("chrome_recorder.start-recording")},{title:i18nString(UIStrings.replayRecording),bindings:e("chrome_recorder.replay-recording")},{title:i18nString(UIStrings.copyShortcut),bindings:[""+(Host.Platform.isMac()?"⌘ C":"Ctrl+C")]},{title:i18nString(UIStrings.toggleCode),bindings:e("chrome_recorder.toggle-code-view")}]}#G(){switch(this.currentPage){case"StartPage":return this.#W();case"AllRecordingsPage":return this.#J();case"RecordingPage":return this.#X();case"CreateRecordingPage":return this.#z()}}#J(){const e=this.#e.getRecordings();return html`
      <${Components.RecordingListView.RecordingListView.litTagName}
        .recordings=${e.map((e=>({storageName:e.storageName,name:e.flow.title})))}
        .replayAllowed=${this.#r}
        @createrecording=${this.#k}
        @deleterecording=${this.#b}
        @openrecording=${this.#F}
        @playrecording=${this.#V}
        >
      </${Components.RecordingListView.RecordingListView.litTagName}>
    `}#W(){return html`
      <${Components.StartView.StartView.litTagName}
        @createrecording=${this.#k}
      ></${Components.StartView.StartView.litTagName}>
    `}#X(){return html`
      <${Components.RecordingView.RecordingView.litTagName}
        .data=${{recording:this.currentRecording?.flow,replayState:this.#o,isRecording:this.isRecording,recordingTogglingInProgress:this.isToggling,currentStep:this.currentStep,currentError:this.recordingError,sections:this.sections,settings:this.settings,recorderSettings:this.#c,lastReplayResult:this.lastReplayResult,replayAllowed:this.#r,breakpointIndexes:this.#s,builtInConverters:this.#a,extensionConverters:this.extensionConverters,replayExtensions:this.replayExtensions,extensionDescriptor:this.viewDescriptor}}
        @networkconditionschanged=${this.#N}
        @timeoutchanged=${this.#I}
        @requestselectorattribute=${e=>{e.send(this.currentRecording?.flow.selectorAttribute)}}
        @recordingfinished=${this.#_}
        @stepchanged=${this.#x.bind(this)}
        @recordingtitlechanged=${this.#T.bind(this)}
        @addstep=${this.#M.bind(this)}
        @removestep=${this.#$.bind(this)}
        @addbreakpoint=${this.#L}
        @removebreakpoint=${this.#j}
        @playrecording=${this.#E}
        @abortreplay=${this.#v}
        @recorderextensionviewclosed=${this.#q}
        @addassertion=${this.#H}
      ></${Components.RecordingView.RecordingView.litTagName}>
    `}#z(){return html`
      <${Components.CreateRecordingView.CreateRecordingView.litTagName}
        .data=${{recorderSettings:this.#c}}
        @recordingstarted=${this.#B}
        @recordingcancelled=${this.#U}
      ></${Components.CreateRecordingView.CreateRecordingView.litTagName}>
    `}#Q=()=>{if(!this.#n)throw new Error("#exportMenuButton not found");return this.#n};#Y(e){e.stopPropagation(),this.#p(),this.exportMenuExpanded=!this.exportMenuExpanded}#Z(){this.exportMenuExpanded=!1}render(){const e=this.#e.getRecordings(),t=this.currentRecording?this.currentRecording.storageName:this.currentPage,r=[0===e.length?{value:"StartPage",name:"No recordings",selected:"StartPage"===t}:{value:"AllRecordingsPage",name:`${e.length} recording(s)`,selected:"AllRecordingsPage"===t},...e.map((e=>({value:e.storageName,name:e.flow.title,selected:t===e.storageName})))];return html`
        <div class="wrapper">
          <div class="header">
            <${Buttons.Button.Button.litTagName}
              @click=${this.#k}
              .data=${{variant:"toolbar",iconName:"plus",disabled:this.#o.isPlaying||this.isRecording||this.isToggling,title:Models.Tooltip.getTooltipForActions(i18nString(UIStrings.createRecording),"chrome_recorder.create-recording")}}
            ></${Buttons.Button.Button.litTagName}>
            <div class="separator"></div>
            <select
              .disabled=${0===e.length||this.#o.isPlaying||this.isRecording||this.isToggling}
              @click=${e=>e.stopPropagation()}
              @change=${this.#F}
            >
              ${LitHtml.Directives.repeat(r,(e=>e.value),(e=>html`<option .selected=${e.selected} value=${e.value}>${e.name}</option>`))}
            </select>
            <div class="separator"></div>
            <${Buttons.Button.Button.litTagName}
              @click=${this.#O}
              .data=${{variant:"toolbar",iconName:"import",title:i18nString(UIStrings.importRecording)}}
            ></${Buttons.Button.Button.litTagName}>
            <${Buttons.Button.Button.litTagName}
              id='origin'
              @click=${this.#Y}
              on-render=${ComponentHelpers.Directives.nodeRenderedCallback((e=>{this.#n=e}))}
              .data=${{variant:"toolbar",iconName:"download",title:i18nString(UIStrings.exportRecording),disabled:!this.currentRecording}}
            ></${Buttons.Button.Button.litTagName}>
            <${Menus.Menu.Menu.litTagName}
              @menucloserequest=${this.#Z}
              @menuitemselected=${this.#A}
              .origin=${this.#Q}
              .showDivider=${!1}
              .showSelectedItem=${!1}
              .showConnector=${!1}
              .open=${this.exportMenuExpanded}
            >
              <${Menus.Menu.MenuGroup.litTagName} .name=${i18nString(UIStrings.export)}>
                ${LitHtml.Directives.repeat(this.#a,(e=>html`
                    <${Menus.Menu.MenuItem.litTagName} .value=${e.getId()}>
                      ${e.getFormatName()}
                    </${Menus.Menu.MenuItem.litTagName}>
                  `))}
              </${Menus.Menu.MenuGroup.litTagName}>
              <${Menus.Menu.MenuGroup.litTagName} .name=${i18nString(UIStrings.exportViaExtensions)}>
                ${LitHtml.Directives.repeat(this.extensionConverters,(e=>html`
                    <${Menus.Menu.MenuItem.litTagName} .value=${e.getId()}>
                    ${e.getFormatName()}
                    </${Menus.Menu.MenuItem.litTagName}>
                  `))}
                <${Menus.Menu.MenuItem.litTagName} .value=${"get-extensions-link"}>
                  ${i18nString(UIStrings.getExtensions)}
                </${Menus.Menu.MenuItem.litTagName}>
              </${Menus.Menu.MenuGroup.litTagName}>
            </${Menus.Menu.Menu.litTagName}>
            <${Buttons.Button.Button.litTagName}
              @click=${this.#b}
              .data=${{variant:"toolbar",iconName:"bin",disabled:!this.currentRecording||this.#o.isPlaying||this.isRecording||this.isToggling,title:i18nString(UIStrings.deleteRecording)}}
            ></${Buttons.Button.Button.litTagName}>
            <div class="separator"></div>
            <button class="continue-button"
              .disabled=${!this.recordingPlayer||!this.#o.isPausedOnBreakpoint}
              title=${i18nString(UIStrings.continueReplay)}
              @click=${()=>this.recordingPlayer?.continue()}>
                <${IconButton.Icon.Icon.litTagName}
                  .data=${{iconName:"resume",color:"var(--icon-color)"}}
                ></${IconButton.Icon.Icon.litTagName}>
            </button>
            <${Buttons.Button.Button.litTagName}
              @click=${()=>this.recordingPlayer?.stepOver()}
              .data=${{variant:"toolbar",iconName:"step-over",disabled:!this.recordingPlayer||!this.#o.isPausedOnBreakpoint,title:i18nString(UIStrings.stepOverReplay)}}
            ></${Buttons.Button.Button.litTagName}>
            <div class="feedback">
              <x-link class="x-link" href=${Components.StartView.FEEDBACK_URL}>${i18nString(UIStrings.sendFeedback)}</x-link>
            </div>
            <div class="separator"></div>
            <${Dialogs.ShortcutDialog.ShortcutDialog.litTagName}
              .data=${{shortcuts:this.#K()}}
            ></${Dialogs.ShortcutDialog.ShortcutDialog.litTagName}>
          </div>
          ${this.importError?html`<div class='error'>Import error: ${this.importError.message}</div>`:""}
          ${this.#G()}
        </div>
      `}};__decorate([state()],RecorderController.prototype,"currentRecordingSession",void 0),__decorate([state()],RecorderController.prototype,"currentRecording",void 0),__decorate([state()],RecorderController.prototype,"currentStep",void 0),__decorate([state()],RecorderController.prototype,"recordingError",void 0),__decorate([state()],RecorderController.prototype,"isRecording",void 0),__decorate([state()],RecorderController.prototype,"isToggling",void 0),__decorate([state()],RecorderController.prototype,"recordingPlayer",void 0),__decorate([state()],RecorderController.prototype,"lastReplayResult",void 0),__decorate([state()],RecorderController.prototype,"currentPage",void 0),__decorate([state()],RecorderController.prototype,"previousPage",void 0),__decorate([state()],RecorderController.prototype,"sections",void 0),__decorate([state()],RecorderController.prototype,"settings",void 0),__decorate([state()],RecorderController.prototype,"importError",void 0),__decorate([state()],RecorderController.prototype,"exportMenuExpanded",void 0),__decorate([state()],RecorderController.prototype,"extensionConverters",void 0),__decorate([state()],RecorderController.prototype,"replayExtensions",void 0),__decorate([state()],RecorderController.prototype,"viewDescriptor",void 0),RecorderController=__decorate([customElement("devtools-recorder-controller")],RecorderController);