import*as i18n from"../i18n/i18n.js";import{ParsedURL}from"./ParsedURL.js";const UIStrings={xhrAndFetch:"`XHR` and `Fetch`",scripts:"Scripts",js:"JS",stylesheets:"Stylesheets",css:"CSS",images:"Images",img:"Img",media:"Media",fonts:"Fonts",font:"Font",documents:"Documents",doc:"Doc",websockets:"WebSockets",ws:"WS",webassembly:"WebAssembly",wasm:"Wasm",manifest:"Manifest",other:"Other",document:"Document",stylesheet:"Stylesheet",image:"Image",script:"Script",texttrack:"TextTrack",fetch:"Fetch",eventsource:"EventSource",websocket:"WebSocket",webtransport:"WebTransport",signedexchange:"SignedExchange",ping:"Ping",cspviolationreport:"CSPViolationReport",preflight:"Preflight",webbundle:"WebBundle"},str_=i18n.i18n.registerUIStrings("core/common/ResourceType.ts",UIStrings),i18nLazyString=i18n.i18n.getLazilyComputedLocalizedString.bind(void 0,str_);export class ResourceType{#e;#t;#s;#r;constructor(e,t,s,r){this.#e=e,this.#t=t,this.#s=s,this.#r=r}static fromMimeType(e){return e?e.startsWith("text/html")?resourceTypes.Document:e.startsWith("text/css")?resourceTypes.Stylesheet:e.startsWith("image/")?resourceTypes.Image:e.startsWith("text/")?resourceTypes.Script:e.includes("font")?resourceTypes.Font:e.includes("script")?resourceTypes.Script:e.includes("octet")?resourceTypes.Other:e.includes("application")?resourceTypes.Script:resourceTypes.Other:resourceTypes.Other}static fromMimeTypeOverride(e){return"application/manifest+json"===e?resourceTypes.Manifest:"application/wasm"===e?resourceTypes.Wasm:"application/webbundle"===e?resourceTypes.WebBundle:null}static fromURL(e){return resourceTypeByExtension.get(ParsedURL.extractExtension(e))||null}static fromName(e){for(const t in resourceTypes){const s=resourceTypes[t];if(s.name()===e)return s}return null}static mimeFromURL(e){const t=ParsedURL.extractName(e);if(mimeTypeByName.has(t))return mimeTypeByName.get(t);let s=ParsedURL.extractExtension(e).toLowerCase();return"html"===s&&t.endsWith(".component.html")&&(s="component.html"),mimeTypeByExtension.get(s)}static mimeFromExtension(e){return mimeTypeByExtension.get(e)}static simplifyContentType(e){return new RegExp("^application.*json$").test(e)?"application/json":e}static mediaTypeForMetrics(e,t,s){return"text/javascript"!==e?e:t?"text/javascript+sourcemapped":s?"text/javascript+minified":"text/javascript+plain"}name(){return this.#e}title(){return this.#t()}category(){return this.#s}isTextType(){return this.#r}isScript(){return"script"===this.#e||"sm-script"===this.#e}hasScripts(){return this.isScript()||this.isDocument()}isStyleSheet(){return"stylesheet"===this.#e||"sm-stylesheet"===this.#e}hasStyleSheets(){return this.isStyleSheet()||this.isDocument()}isDocument(){return"document"===this.#e}isDocumentOrScriptOrStyleSheet(){return this.isDocument()||this.isScript()||this.isStyleSheet()}isFont(){return"font"===this.#e}isImage(){return"image"===this.#e}isFromSourceMap(){return this.#e.startsWith("sm-")}isWebbundle(){return"webbundle"===this.#e}toString(){return this.#e}canonicalMimeType(){return this.isDocument()?"text/html":this.isScript()?"text/javascript":this.isStyleSheet()?"text/css":""}}export class ResourceCategory{title;shortTitle;constructor(e,t){this.title=e,this.shortTitle=t}}export const resourceCategories={XHR:new ResourceCategory(i18nLazyString(UIStrings.xhrAndFetch),i18n.i18n.lockedLazyString("Fetch/XHR")),Script:new ResourceCategory(i18nLazyString(UIStrings.scripts),i18nLazyString(UIStrings.js)),Stylesheet:new ResourceCategory(i18nLazyString(UIStrings.stylesheets),i18nLazyString(UIStrings.css)),Image:new ResourceCategory(i18nLazyString(UIStrings.images),i18nLazyString(UIStrings.img)),Media:new ResourceCategory(i18nLazyString(UIStrings.media),i18nLazyString(UIStrings.media)),Font:new ResourceCategory(i18nLazyString(UIStrings.fonts),i18nLazyString(UIStrings.font)),Document:new ResourceCategory(i18nLazyString(UIStrings.documents),i18nLazyString(UIStrings.doc)),WebSocket:new ResourceCategory(i18nLazyString(UIStrings.websockets),i18nLazyString(UIStrings.ws)),Wasm:new ResourceCategory(i18nLazyString(UIStrings.webassembly),i18nLazyString(UIStrings.wasm)),Manifest:new ResourceCategory(i18nLazyString(UIStrings.manifest),i18nLazyString(UIStrings.manifest)),Other:new ResourceCategory(i18nLazyString(UIStrings.other),i18nLazyString(UIStrings.other))};export const resourceTypes={Document:new ResourceType("document",i18nLazyString(UIStrings.document),resourceCategories.Document,!0),Stylesheet:new ResourceType("stylesheet",i18nLazyString(UIStrings.stylesheet),resourceCategories.Stylesheet,!0),Image:new ResourceType("image",i18nLazyString(UIStrings.image),resourceCategories.Image,!1),Media:new ResourceType("media",i18nLazyString(UIStrings.media),resourceCategories.Media,!1),Font:new ResourceType("font",i18nLazyString(UIStrings.font),resourceCategories.Font,!1),Script:new ResourceType("script",i18nLazyString(UIStrings.script),resourceCategories.Script,!0),TextTrack:new ResourceType("texttrack",i18nLazyString(UIStrings.texttrack),resourceCategories.Other,!0),XHR:new ResourceType("xhr",i18n.i18n.lockedLazyString("XHR"),resourceCategories.XHR,!0),Fetch:new ResourceType("fetch",i18nLazyString(UIStrings.fetch),resourceCategories.XHR,!0),Prefetch:new ResourceType("prefetch",i18n.i18n.lockedLazyString("Prefetch"),resourceCategories.Document,!0),EventSource:new ResourceType("eventsource",i18nLazyString(UIStrings.eventsource),resourceCategories.XHR,!0),WebSocket:new ResourceType("websocket",i18nLazyString(UIStrings.websocket),resourceCategories.WebSocket,!1),WebTransport:new ResourceType("webtransport",i18nLazyString(UIStrings.webtransport),resourceCategories.WebSocket,!1),Wasm:new ResourceType("wasm",i18nLazyString(UIStrings.wasm),resourceCategories.Wasm,!1),Manifest:new ResourceType("manifest",i18nLazyString(UIStrings.manifest),resourceCategories.Manifest,!0),SignedExchange:new ResourceType("signed-exchange",i18nLazyString(UIStrings.signedexchange),resourceCategories.Other,!1),Ping:new ResourceType("ping",i18nLazyString(UIStrings.ping),resourceCategories.Other,!1),CSPViolationReport:new ResourceType("csp-violation-report",i18nLazyString(UIStrings.cspviolationreport),resourceCategories.Other,!1),Other:new ResourceType("other",i18nLazyString(UIStrings.other),resourceCategories.Other,!1),Preflight:new ResourceType("preflight",i18nLazyString(UIStrings.preflight),resourceCategories.Other,!0),SourceMapScript:new ResourceType("sm-script",i18nLazyString(UIStrings.script),resourceCategories.Script,!0),SourceMapStyleSheet:new ResourceType("sm-stylesheet",i18nLazyString(UIStrings.stylesheet),resourceCategories.Stylesheet,!0),WebBundle:new ResourceType("webbundle",i18nLazyString(UIStrings.webbundle),resourceCategories.Other,!1)};const mimeTypeByName=new Map([["Cakefile","text/x-coffeescript"]]);export const resourceTypeByExtension=new Map([["js",resourceTypes.Script],["mjs",resourceTypes.Script],["css",resourceTypes.Stylesheet],["xsl",resourceTypes.Stylesheet],["avif",resourceTypes.Image],["bmp",resourceTypes.Image],["gif",resourceTypes.Image],["ico",resourceTypes.Image],["jpeg",resourceTypes.Image],["jpg",resourceTypes.Image],["jxl",resourceTypes.Image],["png",resourceTypes.Image],["svg",resourceTypes.Image],["tif",resourceTypes.Image],["tiff",resourceTypes.Image],["vue",resourceTypes.Document],["webmanifest",resourceTypes.Manifest],["webp",resourceTypes.Media],["otf",resourceTypes.Font],["ttc",resourceTypes.Font],["ttf",resourceTypes.Font],["woff",resourceTypes.Font],["woff2",resourceTypes.Font],["wasm",resourceTypes.Wasm]]);export const mimeTypeByExtension=new Map([["js","text/javascript"],["mjs","text/javascript"],["css","text/css"],["html","text/html"],["htm","text/html"],["xml","application/xml"],["xsl","application/xml"],["wasm","application/wasm"],["webmanifest","application/manifest+json"],["asp","application/x-aspx"],["aspx","application/x-aspx"],["jsp","application/x-jsp"],["c","text/x-c++src"],["cc","text/x-c++src"],["cpp","text/x-c++src"],["h","text/x-c++src"],["m","text/x-c++src"],["mm","text/x-c++src"],["coffee","text/x-coffeescript"],["dart","application/vnd.dart"],["ts","text/typescript"],["tsx","text/typescript-jsx"],["json","application/json"],["gyp","application/json"],["gypi","application/json"],["map","application/json"],["cs","text/x-csharp"],["go","text/x-go"],["java","text/x-java"],["kt","text/x-kotlin"],["scala","text/x-scala"],["less","text/x-less"],["php","application/x-httpd-php"],["phtml","application/x-httpd-php"],["py","text/x-python"],["sh","text/x-sh"],["gss","text/x-gss"],["sass","text/x-sass"],["scss","text/x-scss"],["vtt","text/vtt"],["ls","text/x-livescript"],["md","text/markdown"],["cljs","text/x-clojure"],["cljc","text/x-clojure"],["cljx","text/x-clojure"],["styl","text/x-styl"],["jsx","text/jsx"],["avif","image/avif"],["bmp","image/bmp"],["gif","image/gif"],["ico","image/ico"],["jpeg","image/jpeg"],["jpg","image/jpeg"],["jxl","image/jxl"],["png","image/png"],["svg","image/svg+xml"],["tif","image/tif"],["tiff","image/tiff"],["webp","image/webp"],["otf","font/otf"],["ttc","font/collection"],["ttf","font/ttf"],["woff","font/woff"],["woff2","font/woff2"],["component.html","text/x.angular"],["svelte","text/x.svelte"],["vue","text/x.vue"]]);