const styles=new CSSStyleSheet;styles.replaceSync('/*\n * Copyright (c) 2015 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n.sensors-view {\n  padding: 12px;\n  display: block;\n}\n\n.sensors-view input {\n  width: 100%;\n  max-width: 120px;\n  margin: -5px 10px 0 0;\n  text-align: end;\n}\n\n.sensors-view input[readonly] {\n  background-color: var(--color-background-elevation-1);\n}\n\n.sensors-view fieldset {\n  border: none;\n  padding: 10px 0;\n  flex: 0 0 auto;\n  margin: 0;\n}\n\n.sensors-view fieldset[disabled] {\n  opacity: 50%;\n}\n\n.orientation-axis-input-container input {\n  max-width: 120px;\n}\n\n.sensors-view input:focus::-webkit-input-placeholder {\n  color: transparent !important; /* stylelint-disable-line declaration-no-important */\n}\n\n.sensors-view .chrome-select {\n  width: 200px;\n}\n\n.sensors-group-title {\n  width: 80px;\n  line-height: 24px;\n}\n\n.sensors-group {\n  display: flex;\n  flex-wrap: wrap;\n  margin-bottom: 10px;\n}\n\n.geo-fields {\n  flex: 2 0 200px;\n}\n\n.latlong-group {\n  display: flex;\n  margin-bottom: 10px;\n}\n\n.latlong-title {\n  width: 70px;\n}\n\n.timezone-error {\n  margin-left: 10px;\n  color: var(--legacy-input-validation-error);\n}\n/* Device Orientation */\n\n.orientation-content {\n  display: flex;\n  flex-wrap: wrap;\n}\n\n.orientation-fields {\n  margin-right: 10px;\n}\n\n.orientation-stage {\n  --override-gradient-color-1: #e1f5fe;\n  --override-gradient-color-2: #b0ebf3;\n  --override-gradient-color-3: #def6f9;\n\n  perspective: 700px;\n  perspective-origin: 50% 50%;\n  width: 160px;\n  height: 150px;\n  background: linear-gradient(var(--override-gradient-color-1) 0%, var(--override-gradient-color-1) 64%, var(--override-gradient-color-2) 64%, var(--override-gradient-color-3) 100%);\n  transition: 0.2s ease opacity, 0.2s ease filter;\n  overflow: hidden;\n  margin-bottom: 10px;\n}\n\n.-theme-with-dark-background .orientation-stage,\n:host-context(.-theme-with-dark-background) .orientation-stage {\n  --override-gradient-color-1: rgb(1 21 30);\n  --override-gradient-color-2: rgb(12 71 79);\n  --override-gradient-color-3: rgb(6 30 33);\n}\n\n.orientation-stage.disabled {\n  filter: grayscale();\n  opacity: 50%;\n}\n\n.orientation-element,\n.orientation-element::before,\n.orientation-element::after {\n  position: absolute;\n  box-sizing: border-box;\n  transform-style: preserve-3d;\n  background: no-repeat;\n  background-size: cover;\n  backface-visibility: hidden;\n}\n\n.orientation-box {\n  width: 62px;\n  height: 122px;\n  left: 0;\n  right: 0;\n  top: 0;\n  bottom: 0;\n  margin: auto;\n  transform: rotate3d(1, 0, 0, 90deg);\n}\n\n.orientation-layer {\n  width: 100%;\n  height: 100%;\n  transform-style: preserve-3d;\n}\n\n.orientation-box.is-animating,\n.is-animating .orientation-layer {\n  transition: transform 300ms cubic-bezier(0.4, 0, 0.2, 1) 0ms;\n}\n\n.orientation-front,\n.orientation-back {\n  width: 62px;\n  height: 122px;\n  border-radius: 8px;\n}\n\n.orientation-front {\n  background-image: var(--image-file-accelerometer-front);\n}\n\n.orientation-back {\n  transform: rotateY(180deg) translateZ(8px);\n  background-image: var(--image-file-accelerometer-back);\n}\n\n.orientation-left,\n.orientation-right {\n  width: 8px;\n  height: 106px;\n  top: 8px;\n  background-position: center center;\n}\n\n.orientation-left {\n  left: -8px;\n  transform-origin: right center;\n  transform: rotateY(-90deg);\n  background-image: var(--image-file-accelerometer-left);\n}\n\n.orientation-right {\n  right: -8px;\n  transform-origin: left center;\n  transform: rotateY(90deg);\n  background-image: var(--image-file-accelerometer-right);\n}\n\n.orientation-left::before,\n.orientation-left::after,\n.orientation-right::before,\n.orientation-right::after {\n  content: "";\n  width: 8px;\n  height: 6px;\n}\n\n.orientation-left::before,\n.orientation-left::after {\n  background-image: var(--image-file-accelerometer-left);\n}\n\n.orientation-right::before,\n.orientation-right::after {\n  background-image: var(--image-file-accelerometer-right);\n}\n\n.orientation-left::before,\n.orientation-right::before {\n  top: -6px;\n  transform-origin: center bottom;\n  transform: rotateX(26deg);\n  background-position: center top;\n}\n\n.orientation-left::after,\n.orientation-right::after {\n  bottom: -6px;\n  transform-origin: center top;\n  transform: rotateX(-25deg);\n  background-position: center bottom;\n}\n\n.orientation-top,\n.orientation-bottom {\n  width: 50px;\n  height: 8px;\n  left: 8px;\n  background-position: center center;\n}\n\n.orientation-top {\n  top: -8px;\n  transform-origin: center bottom;\n  transform: rotateX(90deg);\n  background-image: var(--image-file-accelerometer-top);\n}\n\n.orientation-bottom {\n  bottom: -8px;\n  transform-origin: center top;\n  transform: rotateX(-90deg);\n  background-image: var(--image-file-accelerometer-bottom);\n}\n\n.orientation-top::before,\n.orientation-top::after,\n.orientation-bottom::before,\n.orientation-bottom::after {\n  content: "";\n  width: 8px;\n  height: 8px;\n}\n\n.orientation-top::before,\n.orientation-top::after {\n  background-image: var(--image-file-accelerometer-top);\n}\n\n.orientation-bottom::before,\n.orientation-bottom::after {\n  background-image: var(--image-file-accelerometer-bottom);\n}\n\n.orientation-top::before,\n.orientation-bottom::before {\n  left: -6px;\n  transform-origin: right center;\n  transform: rotateY(-26deg);\n  background-position: left center;\n}\n\n.orientation-top::after,\n.orientation-bottom::after {\n  right: -6px;\n  transform-origin: left center;\n  transform: rotateY(26deg);\n  background-position: right center;\n}\n\n.orientation-axis-input-container {\n  margin-bottom: 10px;\n}\n\n.orientation-reset-button {\n  min-width: 80px;\n}\n\nfieldset.device-orientation-override-section {\n  margin: 0;\n  display: flex;\n}\n\n.panel-section-separator {\n  height: 1px;\n  margin-bottom: 20px;\n  margin-left: -12px;\n  margin-right: -12px;\n  background: var(--sys-color-divider);\n}\n\nbutton.text-button {\n  margin: 4px 0 0 10px;\n}\n\n@media (forced-colors: active) {\n  .sensors-view fieldset[disabled] {\n    opacity: 100%;\n  }\n}\n\n.chrome-select-label {\n  margin-bottom: 16px;\n}\n\n/*# sourceURL=sensors.css */\n');export default styles;