import{assert}from"../../util/assert.js";import{Deferred}from"../../util/Deferred.js";import{CDPSession}from"../Connection.js";import{ProtocolError,TargetCloseError,TimeoutError}from"../Errors.js";import{getPageContent,setPageContent,waitWithTimeout}from"../util.js";import{Realm}from"./Realm.js";import{debugError}from"./utils.js";export const lifeCycleToSubscribedEvent=new Map([["load","browsingContext.load"],["domcontentloaded","browsingContext.domContentLoaded"]]);const lifeCycleToReadinessState=new Map([["load","complete"],["domcontentloaded","interactive"]]);export const cdpSessions=new Map;export class CDPSessionWrapper extends CDPSession{#t;#e=Deferred.create();#s=!1;constructor(t,e){super(),this.#t=t,this.#t.supportsCDP()&&(e?(this.#e.resolve(e),cdpSessions.set(e,this)):t.connection.send("cdp.getSession",{context:t.id}).then((t=>{this.#e.resolve(t.result.session),cdpSessions.set(t.result.session,this)})).catch((t=>{this.#e.reject(t)})))}connection(){}async send(t,...e){if(!this.#t.supportsCDP())throw new Error("CDP support is required for this feature. The current browser does not support CDP.");if(this.#s)throw new TargetCloseError(`Protocol error (${t}): Session closed. Most likely the page has been closed.`);const s=await this.#e.valueOrThrow(),{result:o}=await this.#t.connection.send("cdp.sendCommand",{method:t,params:e[0],session:s});return o.result}async detach(){cdpSessions.delete(this.id()),this.#t.supportsCDP()&&await this.#t.cdpSession.send("Target.detachFromTarget",{sessionId:this.id()}),this.#s=!0}id(){const t=this.#e.value();return t instanceof Error||void 0===t?"":t}}export const BrowsingContextEmittedEvents={Created:Symbol("BrowsingContext.created"),Destroyed:Symbol("BrowsingContext.destroyed")};export class BrowsingContext extends Realm{#o;#i;#n;#r;#a="";constructor(t,e,s){super(t,e.context),this.connection=t,this.#o=e.context,this.#i=e.url,this.#r=e.parent,this.#a=s,this.#n=new CDPSessionWrapper(this,void 0),this.on("browsingContext.domContentLoaded",this.#d.bind(this)),this.on("browsingContext.load",this.#d.bind(this))}supportsCDP(){return!this.#a.toLowerCase().includes("firefox")}#d(t){this.url=t.url}createSandboxRealm(t){return new Realm(this.connection,this.#o,t)}get url(){return this.#i}set url(t){this.#i=t}get id(){return this.#o}get parent(){return this.#r}get cdpSession(){return this.#n}navigated(t){this.#i=t}async goto(t,e){const{waitUntil:s="load",timeout:o}=e,i=lifeCycleToReadinessState.get(getWaitUntilSingle(s));try{const{result:e}=await waitWithTimeout(this.connection.send("browsingContext.navigate",{url:t,context:this.#o,wait:i}),"Navigation",o);return this.#i=e.url,e.navigation}catch(e){throw e instanceof ProtocolError?e.message+=` at ${t}`:e instanceof TimeoutError&&(e.message="Navigation timeout of "+o+" ms exceeded"),e}}async reload(t){const{waitUntil:e="load",timeout:s}=t,o=lifeCycleToReadinessState.get(getWaitUntilSingle(e));await waitWithTimeout(this.connection.send("browsingContext.reload",{context:this.#o,wait:o}),"Navigation",s)}async setContent(t,e){const{waitUntil:s="load",timeout:o}=e,i=lifeCycleToSubscribedEvent.get(getWaitUntilSingle(s));await Promise.all([setPageContent(this,t),waitWithTimeout(new Promise((t=>{this.once(i,(()=>{t()}))})),i,o)])}async content(){return await this.evaluate(getPageContent)}async sendCDPCommand(t,...e){return this.#n.send(t,...e)}title(){return this.evaluate((()=>document.title))}dispose(){this.removeAllListeners(),this.connection.unregisterBrowsingContexts(this.#o),this.#n.detach().catch(debugError)}}export function getWaitUntilSingle(t){if(Array.isArray(t)&&t.length>1)throw new Error("BiDi support only single `waitUntil` argument");const e=Array.isArray(t)?t.find((t=>"domcontentloaded"===t||"load"===t)):t;if("networkidle0"===e||"networkidle2"===e)throw new Error(`BiDi does not support 'waitUntil' ${e}`);return assert(e,`Invalid waitUntil option ${e}`),e}