import*as Common from"../../../../core/common/common.js";import*as i18n from"../../../../core/i18n/i18n.js";import*as Platform from"../../../../core/platform/platform.js";import*as TextUtils from"../../../../models/text_utils/text_utils.js";import*as Diff from"../../../../third_party/diff/diff.js";import*as TextPrompt from"../../../../ui/components/text_prompt/text_prompt.js";import*as UI from"../../legacy.js";import filteredListWidgetStyles from"./filteredListWidget.css.js";const UIStrings={quickOpenPrompt:"Quick open prompt",quickOpen:"Quick open",noResultsFound:"No results found"},str_=i18n.i18n.registerUIStrings("ui/legacy/components/quick_open/FilteredListWidget.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class FilteredListWidget extends(Common.ObjectWrapper.eventMixin(UI.Widget.VBox)){promptHistory;scoringTimer;filterTimer;loadTimeout;refreshListWithCurrentResult;dialog;query="";inputBoxElement;hintElement;bottomElementsContainer;progressElement;progressBarElement;items;list;itemElementsContainer;notFoundElement;prefix="";provider;queryChangedCallback;constructor(t,e,i){super(!0),this.promptHistory=e||[],this.scoringTimer=0,this.filterTimer=0,this.loadTimeout=0,this.contentElement.classList.add("filtered-list-widget");const s=this.onKeyDown.bind(this);this.contentElement.addEventListener("keydown",s,!0),UI.ARIAUtils.markAsCombobox(this.contentElement);const r=this.contentElement.createChild("div","hbox");this.inputBoxElement=new TextPrompt.TextPrompt.TextPrompt,this.inputBoxElement.data={ariaLabel:i18nString(UIStrings.quickOpenPrompt),prefix:"",suggestion:""},this.inputBoxElement.addEventListener(TextPrompt.TextPrompt.PromptInputEvent.eventName,this.onInput.bind(this),!1),r.appendChild(this.inputBoxElement),this.hintElement=r.createChild("span","filtered-list-widget-hint"),this.bottomElementsContainer=this.contentElement.createChild("div","vbox"),this.progressElement=this.bottomElementsContainer.createChild("div","filtered-list-widget-progress"),this.progressBarElement=this.progressElement.createChild("div","filtered-list-widget-progress-bar"),this.items=new UI.ListModel.ListModel,this.list=new UI.ListControl.ListControl(this.items,this,UI.ListControl.ListMode.EqualHeightItems),this.itemElementsContainer=this.list.element,this.itemElementsContainer.classList.add("container"),this.bottomElementsContainer.appendChild(this.itemElementsContainer),this.itemElementsContainer.addEventListener("click",this.onClick.bind(this),!1),this.itemElementsContainer.addEventListener("mousemove",this.onMouseMove.bind(this),!1),UI.ARIAUtils.markAsListBox(this.itemElementsContainer),UI.ARIAUtils.setControls(this.inputBoxElement,this.itemElementsContainer),UI.ARIAUtils.setAutocomplete(this.inputBoxElement,UI.ARIAUtils.AutocompleteInteractionModel.list),this.notFoundElement=this.bottomElementsContainer.createChild("div","not-found-text"),this.notFoundElement.classList.add("hidden"),this.setDefaultFocusedElement(this.inputBoxElement),this.provider=t,this.queryChangedCallback=i}static highlightRanges(t,e,i){if(!e)return!1;function s(t,e){const i=Diff.Diff.DiffWrapper.charDiff(e,t);let s=0;const r=[];for(let t=0;t<i.length;++t){const e=i[t];if(e[0]===Diff.Diff.Operation.Equal)r.push(new TextUtils.TextRange.SourceRange(s,e[1].length));else if(e[0]!==Diff.Diff.Operation.Insert)return null;s+=e[1].length}return r}if(null===t.textContent)return!1;const r=t.textContent;let n=s(r,e);return n&&!i||(n=s(r.toUpperCase(),e.toUpperCase())),!!n&&(UI.UIUtils.highlightRangesWithStyleClass(t,n,"highlight"),!0)}setCommandPrefix(t){this.inputBoxElement.setPrefix(t)}setCommandSuggestion(t){this.inputBoxElement.setSuggestion(t)}setHintElement(t){this.hintElement.textContent=t}setPromptTitle(t){UI.ARIAUtils.setLabel(this.inputBoxElement,t)}showAsDialog(t){t||(t=i18nString(UIStrings.quickOpen)),this.dialog=new UI.Dialog.Dialog,UI.ARIAUtils.setLabel(this.dialog.contentElement,t),this.dialog.setMaxContentSize(new UI.Geometry.Size(504,340)),this.dialog.setSizeBehavior("SetExactWidthMaxHeight"),this.dialog.setContentPosition(null,22),this.dialog.contentElement.style.setProperty("border-radius","4px"),this.show(this.dialog.contentElement),UI.ARIAUtils.setExpanded(this.contentElement,!0),this.dialog.once("hidden").then((()=>{this.dispatchEventToListeners("hidden")})),this.dialog.show()}setPrefix(t){this.prefix=t}setProvider(t){t!==this.provider&&(this.provider&&this.provider.detach(),this.clearTimers(),this.provider=t,this.isShowing()&&this.attachProvider())}setQuerySelectedRange(t,e){this.inputBoxElement.setSelectedRange(t,e)}attachProvider(){this.items.replaceAll([]),this.list.invalidateItemHeight(),this.provider&&(this.provider.setRefreshCallback(this.itemsLoaded.bind(this,this.provider)),this.provider.attach()),this.itemsLoaded(this.provider)}cleanValue(){return this.query.substring(this.prefix.length).trim()}wasShown(){this.registerCSSFiles([filteredListWidgetStyles]),this.attachProvider()}willHide(){this.provider&&this.provider.detach(),this.clearTimers(),UI.ARIAUtils.setExpanded(this.contentElement,!1)}clearTimers(){clearTimeout(this.filterTimer),clearTimeout(this.scoringTimer),clearTimeout(this.loadTimeout),this.filterTimer=0,this.scoringTimer=0,this.loadTimeout=0,this.refreshListWithCurrentResult=void 0}onEnter(t){if(!this.provider)return;t.preventDefault();const e=this.provider.itemCount()?this.list.selectedItem():null;this.selectItem(e),this.dialog&&this.dialog.hide()}itemsLoaded(t){this.loadTimeout||t!==this.provider||(this.loadTimeout=window.setTimeout(this.updateAfterItemsLoaded.bind(this),0))}updateAfterItemsLoaded(){this.loadTimeout=0,this.filterItems()}createElementForItem(t){const e=document.createElement("div");e.className="filtered-list-widget-item-wrapper";const i=e.createChild("div"),s=this.provider&&this.provider.renderAsTwoRows();i.className="filtered-list-widget-item "+(s?"two-rows":"one-row");const r=i.createChild("div","filtered-list-widget-title"),n=i.createChild("div","filtered-list-widget-subtitle");return n.textContent="​",this.provider&&this.provider.renderItem(t,this.cleanValue(),r,n),UI.ARIAUtils.markAsOption(i),e}heightForItem(t){return 0}isItemSelectable(t){return!0}selectedItemChanged(t,e,i,s){i&&i.classList.remove("selected"),s&&s.classList.add("selected"),UI.ARIAUtils.setActiveDescendant(this.inputBoxElement,s)}onClick(t){const e=this.list.itemForNode(t.target);null!==e&&(t.consume(!0),this.selectItem(e),this.dialog&&this.dialog.hide())}onMouseMove(t){const e=this.list.itemForNode(t.target);null!==e&&this.list.selectItem(e)}setQuery(t){this.query=t,this.inputBoxElement.focus(),this.inputBoxElement.setText(t),this.queryChanged(),this.scheduleFilter()}tabKeyPressed(){const t=this.query;let e;for(let i=this.promptHistory.length-1;i>=0;i--)if(this.promptHistory[i]!==t&&this.promptHistory[i].startsWith(t)){e=this.promptHistory[i];break}if(e){const i=this.inputBoxElement.getComponentSelection();return i&&""!==i.toString().trim()?(this.setQuery(e),!0):(this.inputBoxElement.focus(),this.inputBoxElement.setText(e),this.setQuerySelectedRange(t.length,e.length),!0)}return this.list.selectNextItem(!0,!1)}itemsFilteredForTest(){}filterItems(){if(this.filterTimer=0,this.scoringTimer&&(clearTimeout(this.scoringTimer),this.scoringTimer=0,this.refreshListWithCurrentResult&&this.refreshListWithCurrentResult()),!this.provider)return this.bottomElementsContainer.classList.toggle("hidden",!0),void this.itemsFilteredForTest();this.bottomElementsContainer.classList.toggle("hidden",!1),this.progressBarElement.style.transform="scaleX(0)",this.progressBarElement.classList.remove("filtered-widget-progress-fade","hidden");const t=this.provider.rewriteQuery(this.cleanValue()),e=t?Platform.StringUtilities.filterRegex(t):null,i=[],s=[],r=[],n=100;let o=0;const l=[],h=window.performance.now(),d=Platform.NumberUtilities.clamp(10,500,this.provider.itemCount()/10|0);function a(t,e){return e-t}(function m(c){if(!this.provider)return;this.scoringTimer=0;let u,p=0;for(u=c;u<this.provider.itemCount()&&p<d;++u){if(e&&!e.test(this.provider.itemKeyAt(u)))continue;const h=this.provider.itemScoreAt(u,t);if(t&&p++,h>o||s.length<n){const t=Platform.ArrayUtilities.upperBound(s,h,a);if(s.splice(t,0,h),r.splice(t,0,u),s.length>n){const t=r[r.length-1];t&&l.push(t),s.length=n,r.length=n}const e=s[s.length-1];e&&(o=e)}else i.push(u)}if(this.refreshListWithCurrentResult=this.refreshList.bind(this,r,l,i),u<this.provider.itemCount())return this.scoringTimer=window.setTimeout(m.bind(this,u),0),void(window.performance.now()-h>50&&(this.progressBarElement.style.transform="scaleX("+u/this.provider.itemCount()+")"));window.performance.now()-h>100?(this.progressBarElement.style.transform="scaleX(1)",this.progressBarElement.classList.add("filtered-widget-progress-fade")):this.progressBarElement.classList.add("hidden");this.refreshListWithCurrentResult()}).call(this,0)}refreshList(t,e,i){this.refreshListWithCurrentResult=void 0,i=[...t,...e,...i],this.updateNotFoundMessage(Boolean(i.length));const s=this.list.element.offsetHeight;this.items.replaceAll(i),i.length&&this.list.selectItem(i[0]),this.list.element.offsetHeight!==s&&this.list.viewportResized(),this.itemsFilteredForTest()}updateNotFoundMessage(t){this.list.element.classList.toggle("hidden",!t),this.notFoundElement.classList.toggle("hidden",t),!t&&this.provider&&(this.notFoundElement.textContent=this.provider.notFoundText(this.cleanValue()),UI.ARIAUtils.alert(this.notFoundElement.textContent))}onInput(t){this.query=t.data,this.queryChanged(),this.scheduleFilter()}async queryChanged(){this.hintElement.classList.toggle("hidden",Boolean(this.query)),this.queryChangedCallback&&await this.queryChangedCallback(this.query),this.provider&&this.provider.queryChanged(this.cleanValue())}updateSelectedItemARIA(t,e){return!1}onKeyDown(t){let e=!1;switch(t.key){case Platform.KeyboardUtilities.ENTER_KEY:return void this.onEnter(t);case Platform.KeyboardUtilities.TAB_KEY:if(t.shiftKey){e=this.list.selectPreviousItem(!0,!1);break}e=this.tabKeyPressed();break;case"ArrowUp":e=this.list.selectPreviousItem(!0,!1);break;case"ArrowDown":e=this.list.selectNextItem(!0,!1);break;case"PageUp":e=this.list.selectItemPreviousPage(!1);break;case"PageDown":e=this.list.selectItemNextPage(!1)}e&&t.consume(!0)}scheduleFilter(){this.filterTimer||(this.filterTimer=window.setTimeout(this.filterItems.bind(this),0))}selectItem(t){this.promptHistory.push(this.query),this.promptHistory.length>100&&this.promptHistory.shift(),this.provider&&this.provider.selectItem(t,this.cleanValue())}}export class Provider{refreshCallback;constructor(){}setRefreshCallback(t){this.refreshCallback=t}attach(){}itemCount(){return 0}itemKeyAt(t){return""}itemScoreAt(t,e){return 1}renderItem(t,e,i,s){}renderAsTwoRows(){return!1}selectItem(t,e){}refresh(){this.refreshCallback&&this.refreshCallback()}rewriteQuery(t){return t}queryChanged(t){}notFoundText(t){return i18nString(UIStrings.noResultsFound)}detach(){}}const registeredProviders=[];export function registerProvider(t){registeredProviders.push(t)}export function getRegisteredProviders(){return registeredProviders}